<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:07 +0000">

<link rel="stylesheet" type="text/css" href="../../../stylesheet.css">
<link rel="start" href="../../../overview-summary.html">

<title>doclets/standard/standard.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../../overview-files.html">Files</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../todo-list.html">Todo</a></li>
<li><a href="../../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../../index.html" target="_top">Frames</a>
<a href="../../../source/doclets/standard/standard.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>doclets/standard/standard.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2004 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>// load classes
<a name="line22"></a>require('htmlWriter.php');
<a name="line23"></a>require('frameOutputWriter.php');
<a name="line24"></a>require('packageIndexWriter.php');
<a name="line25"></a>require('packageIndexFrameWriter.php');
<a name="line26"></a>require('packageFrameWriter.php');
<a name="line27"></a>require('packageWriter.php');
<a name="line28"></a>require('classWriter.php');
<a name="line29"></a>require('functionWriter.php');
<a name="line30"></a>require('globalWriter.php');
<a name="line31"></a>require('indexWriter.php');
<a name="line32"></a>require('deprecatedWriter.php');
<a name="line33"></a>require('todoWriter.php');
<a name="line34"></a>require('sourceWriter.php');
<a name="line35"></a>
<a name="line36"></a>/** The standard doclet. This doclet generates HTML output similar to that
<a name="line37"></a> * produced by the Javadoc standard doclet.
<a name="line38"></a> *
<a name="line39"></a> * @package PHPDoctor\Doclets\Standard
<a name="line40"></a> */
<a name="line41"></a>class Standard extends Doclet
<a name="line42"></a>{
<a name="line43"></a>
<a name="line44"></a>	/** A reference to the root doc.
<a name="line45"></a>	 *
<a name="line46"></a>	 * @var rootDoc
<a name="line47"></a>	 */
<a name="line48"></a>	var $_rootDoc;
<a name="line49"></a>
<a name="line50"></a>	/** The directory to place the generated files.
<a name="line51"></a>	 *
<a name="line52"></a>	 * @var str
<a name="line53"></a>	 */
<a name="line54"></a>	var $_d;
<a name="line55"></a>
<a name="line56"></a>	/** Specifies the title to be placed in the HTML <title> tag.
<a name="line57"></a>	 *
<a name="line58"></a>	 * @var str
<a name="line59"></a>	 */
<a name="line60"></a>	var $_windowTitle = 'The Unknown Project';
<a name="line61"></a>
<a name="line62"></a>	/** Specifies the title to be placed near the top of the overview summary
<a name="line63"></a>	 * file.
<a name="line64"></a>	 *
<a name="line65"></a>	 * @var str
<a name="line66"></a>	 */
<a name="line67"></a>	var $_docTitle = 'The Unknown Project';
<a name="line68"></a>
<a name="line69"></a>	/** Specifies the header text to be placed at the top of each output file.
<a name="line70"></a>	 * The header will be placed to the right of the upper navigation bar.
<a name="line71"></a>	 *
<a name="line72"></a>	 * @var str
<a name="line73"></a>	 */
<a name="line74"></a>	var $_header = 'Unknown';
<a name="line75"></a>
<a name="line76"></a>	/** Specifies the footer text to be placed at the bottom of each output file.
<a name="line77"></a>	 * The footer will be placed to the right of the lower navigation bar.
<a name="line78"></a>	 *
<a name="line79"></a>	 * @var str
<a name="line80"></a>	 */
<a name="line81"></a>	var $_footer = 'Unknown';
<a name="line82"></a>
<a name="line83"></a>	/** Specifies the text to be placed at the bottom of each output file. The
<a name="line84"></a>	 * text will be placed at the bottom of the page, below the lower navigation
<a name="line85"></a>	 * bar.
<a name="line86"></a>	 *
<a name="line87"></a>	 * @var str
<a name="line88"></a>	 */
<a name="line89"></a>	var $_bottom = 'This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a>';
<a name="line90"></a>
<a name="line91"></a>	/** Create a class tree?
<a name="line92"></a>	 *
<a name="line93"></a>	 * @var str
<a name="line94"></a>	 */
<a name="line95"></a>	var $_tree = TRUE;
<a name="line96"></a>	
<a name="line97"></a>	/** Whether or not to parse the code with GeSHi and include the formatted files
<a name="line98"></a>	 * in the documentation.
<a name="line99"></a>	 *
<a name="line100"></a>	 * @var boolean
<a name="line101"></a>	 */
<a name="line102"></a>	var $_includeSource = TRUE;
<a name="line103"></a>
<a name="line104"></a>	/** Doclet constructor.
<a name="line105"></a>	 *
<a name="line106"></a>	 * @param RootDoc rootDoc
<a name="line107"></a>	 * @param TextFormatter formatter
<a name="line108"></a>	 */
<a name="line109"></a>	function standard(&$rootDoc, $formatter)
<a name="line110"></a>    {
<a name="line111"></a>	
<a name="line112"></a>		// set doclet options
<a name="line113"></a>		$this->_rootDoc =& $rootDoc;
<a name="line114"></a>		$phpdoctor =& $rootDoc->phpdoctor();
<a name="line115"></a>		$options =& $rootDoc->options();
<a name="line116"></a>		
<a name="line117"></a>		$this->formatter = $formatter;
<a name="line118"></a>		
<a name="line119"></a>		if (isset($options['d'])) {
<a name="line120"></a>			$this->_d = $phpdoctor->makeAbsolutePath($options['d'], $phpdoctor->sourcePath());
<a name="line121"></a>		} elseif (isset($options['output_dir'])) {
<a name="line122"></a>			$this->_d = $phpdoctor->makeAbsolutePath($options['output_dir'], $phpdoctor->sourcePath());
<a name="line123"></a>		} else {
<a name="line124"></a>			$this->_d = $phpdoctor->makeAbsolutePath('apidocs', $phpdoctor->sourcePath());
<a name="line125"></a>		}
<a name="line126"></a>		$this->_d = $phpdoctor->fixPath($this->_d);
<a name="line127"></a>		
<a name="line128"></a>		if (is_dir($this->_d)) {
<a name="line129"></a>			$phpdoctor->warning('Output directory already exists, overwriting');
<a name="line130"></a>		} else {
<a name="line131"></a>			mkdir($this->_d);
<a name="line132"></a>		}
<a name="line133"></a>		$phpdoctor->verbose('Setting output directory to "'.$this->_d.'"');
<a name="line134"></a>		
<a name="line135"></a>		if (isset($options['windowtitle'])) $this->_windowTitle = $options['windowtitle'];
<a name="line136"></a>		if (isset($options['doctitle'])) $this->_docTitle = $options['doctitle'];
<a name="line137"></a>		if (isset($options['header'])) $this->_header = $options['header'];
<a name="line138"></a>		if (isset($options['footer'])) $this->_footer = $options['footer'];
<a name="line139"></a>		if (isset($options['bottom'])) $this->_bottom = $options['bottom'];
<a name="line140"></a>
<a name="line141"></a>		if (isset($options['tree'])) $this->_tree = $options['tree'];
<a name="line142"></a>		
<a name="line143"></a>		if (isset($options['include_source'])) $this->_includeSource = $options['include_source'];
<a name="line144"></a>        if ($this->_includeSource) {
<a name="line145"></a>            @include_once 'geshi/geshi.php';
<a name="line146"></a>            if (!class_exists('GeSHi')) {
<a name="line147"></a>                $phpdoctor->warning('Could not find GeSHi in "geshi/geshi.php", not pretty printing source');
<a name="line148"></a>            }
<a name="line149"></a>		}
<a name="line150"></a>		
<a name="line151"></a>		// write frame
<a name="line152"></a>		$frameOutputWriter =& new frameOutputWriter($this);
<a name="line153"></a>
<a name="line154"></a>		// write overview summary
<a name="line155"></a>		$packageIndexWriter =& new packageIndexWriter($this);
<a name="line156"></a>
<a name="line157"></a>		// write package overview frame
<a name="line158"></a>		$packageIndexFrameWriter =& new packageIndexFrameWriter($this);
<a name="line159"></a>
<a name="line160"></a>		// write package summaries
<a name="line161"></a>		$packageWriter =& new packageWriter($this);
<a name="line162"></a>		
<a name="line163"></a>		// write package frame
<a name="line164"></a>		$packageFrameWriter =& new packageFrameWriter($this);
<a name="line165"></a>        
<a name="line166"></a>		// write classes
<a name="line167"></a>		$classWriter =& new classWriter($this);
<a name="line168"></a>		
<a name="line169"></a>		// write global functions
<a name="line170"></a>		$functionWriter =& new functionWriter($this);
<a name="line171"></a>		
<a name="line172"></a>		// write global variables
<a name="line173"></a>		$globalWriter =& new globalWriter($this);
<a name="line174"></a>
<a name="line175"></a>		// write index
<a name="line176"></a>		$indexWriter =& new indexWriter($this);
<a name="line177"></a>        
<a name="line178"></a>		// write deprecated index
<a name="line179"></a>		$deprecatedWriter =& new deprecatedWriter($this);
<a name="line180"></a>		
<a name="line181"></a>		// write todo index
<a name="line182"></a>		$todoWriter =& new todoWriter($this);
<a name="line183"></a>		
<a name="line184"></a>		// write source files
<a name="line185"></a>		if ($this->_includeSource) {
<a name="line186"></a>            $sourceWriter =& new sourceWriter($this);
<a name="line187"></a>		}
<a name="line188"></a>		
<a name="line189"></a>		// copy stylesheet
<a name="line190"></a>		$phpdoctor->message('Copying stylesheet');
<a name="line191"></a>		copy($phpdoctor->docletPath().'stylesheet.css', $this->_d.'stylesheet.css');
<a name="line192"></a>	
<a name="line193"></a>	}
<a name="line194"></a>
<a name="line195"></a>	/** Return a reference to the root doc.
<a name="line196"></a>	 *
<a name="line197"></a>	 * @return RootDoc
<a name="line198"></a>	 */
<a name="line199"></a>	function &rootDoc()
<a name="line200"></a>    {
<a name="line201"></a>		return $this->_rootDoc;
<a name="line202"></a>	}
<a name="line203"></a>	
<a name="line204"></a>	/** Return a reference to the application object.
<a name="line205"></a>	 *
<a name="line206"></a>	 * @return PHPDoctor
<a name="line207"></a>	 */
<a name="line208"></a>	function &phpdoctor()
<a name="line209"></a>    {
<a name="line210"></a>		return $this->_rootDoc->phpdoctor();
<a name="line211"></a>	}
<a name="line212"></a>
<a name="line213"></a>	/** Get the destination path to write the doclet output to.
<a name="line214"></a>	 *
<a name="line215"></a>	 * @return str
<a name="line216"></a>	 */	
<a name="line217"></a>	function destinationPath()
<a name="line218"></a>    {
<a name="line219"></a>		return $this->_d;
<a name="line220"></a>	}
<a name="line221"></a>
<a name="line222"></a>	/** Return the title to be placed in the HTML <title> tag.
<a name="line223"></a>	 *
<a name="line224"></a>	 * @return str
<a name="line225"></a>	 */
<a name="line226"></a>	function windowTitle()
<a name="line227"></a>    {
<a name="line228"></a>		return $this->_windowTitle;
<a name="line229"></a>	}
<a name="line230"></a>
<a name="line231"></a>	/** Return the title to be placed near the top of the overview summary
<a name="line232"></a>	 * file.
<a name="line233"></a>	 *
<a name="line234"></a>	 * @return str
<a name="line235"></a>	 */
<a name="line236"></a>	function docTitle()
<a name="line237"></a>    {
<a name="line238"></a>		return $this->_docTitle;
<a name="line239"></a>	}
<a name="line240"></a>
<a name="line241"></a>	/** Return the header text to be placed at the top of each output file.
<a name="line242"></a>	 * The header will be placed to the right of the upper navigation bar.
<a name="line243"></a>	 *
<a name="line244"></a>	 * @return str
<a name="line245"></a>	 */
<a name="line246"></a>	function getHeader()
<a name="line247"></a>    {
<a name="line248"></a>		return $this->_header;
<a name="line249"></a>	}
<a name="line250"></a>
<a name="line251"></a>	/** Return the footer text to be placed at the bottom of each output file.
<a name="line252"></a>	 * The footer will be placed to the right of the lower navigation bar.
<a name="line253"></a>	 *
<a name="line254"></a>	 * @return str
<a name="line255"></a>	 */
<a name="line256"></a>	function getFooter()
<a name="line257"></a>    {
<a name="line258"></a>		return $this->_footer;
<a name="line259"></a>	}
<a name="line260"></a>
<a name="line261"></a>	/** Return the text to be placed at the bottom of each output file. The
<a name="line262"></a>	 * text will be placed at the bottom of the page, below the lower navigation
<a name="line263"></a>	 * bar.
<a name="line264"></a>	 *
<a name="line265"></a>	 * @return str
<a name="line266"></a>	 */
<a name="line267"></a>	function bottom()
<a name="line268"></a>    {
<a name="line269"></a>		return $this->_bottom;
<a name="line270"></a>	}
<a name="line271"></a>
<a name="line272"></a>	/** Return whether to create a class tree or not.
<a name="line273"></a>	 *
<a name="line274"></a>	 * @return bool
<a name="line275"></a>	 */
<a name="line276"></a>	function tree()
<a name="line277"></a>    {
<a name="line278"></a>		return $this->_tree;
<a name="line279"></a>	}
<a name="line280"></a>
<a name="line281"></a>	/** Return the version of PHPDoctor.
<a name="line282"></a>	 *
<a name="line283"></a>	 * @return str
<a name="line284"></a>	 */
<a name="line285"></a>	function version()
<a name="line286"></a>    {
<a name="line287"></a>		$phpdoctor =& $this->_rootDoc->phpdoctor();
<a name="line288"></a>		return $phpdoctor->version();
<a name="line289"></a>	}
<a name="line290"></a>	
<a name="line291"></a>	/** Should we be outputting the source code?
<a name="line292"></a>	 *
<a name="line293"></a>	 * @return bool
<a name="line294"></a>	 */
<a name="line295"></a>	function includeSource()
<a name="line296"></a>	{
<a name="line297"></a>	    return $this->_includeSource;
<a name="line298"></a>	}
<a name="line299"></a>	
<a name="line300"></a>    /**
<a name="line301"></a>     * Format a URL link
<a name="line302"></a>     *
<a name="line303"></a>     * @param str url
<a name="line304"></a>     * @param str text
<a name="line305"></a>     */
<a name="line306"></a>    function formatLink($url, $text)
<a name="line307"></a>    {
<a name="line308"></a>        return '<a href="'.$url.'">'.$text.'</a>';
<a name="line309"></a>    }
<a name="line310"></a>    
<a name="line311"></a>    /**
<a name="line312"></a>     * Format text as a piece of code
<a name="line313"></a>     *
<a name="line314"></a>     * @param str text
<a name="line315"></a>     * @return str
<a name="line316"></a>     */
<a name="line317"></a>    function asCode($text)
<a name="line318"></a>    {
<a name="line319"></a>        return '<code>'.$text.'</code>';
<a name="line320"></a>    }
<a name="line321"></a>    
<a name="line322"></a>}
<a name="line323"></a>?>
<a name="line324"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../../overview-files.html">Files</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../todo-list.html">Todo</a></li>
<li><a href="../../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../../index.html" target="_top">Frames</a>
<a href="../../../source/doclets/standard/standard.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>